<section>
  <h3>Choose input values</h3>
  <app-interval-form (intervalChange)="setInterval($event)"></app-interval-form>
  <form [formGroup]="inputValuesFormGroup" (ngSubmit)="onSubmit()">
    <mat-form-field>
      <mat-label>
        &#603; (result interval length)
      </mat-label>
      <input type="number" matInput formControlName="resultIntervalLength"/>
    </mat-form-field>
    <mat-form-field>
      <mat-label>
        &#948; (distinguishing constant)
      </mat-label>
      <input type="number" matInput formControlName="constant"/>
    </mat-form-field>
    <button mat-raised-button color="primary" [disabled]="!inputValuesFormGroup.valid">
      Submit input values
    </button>
  </form>
</section>

<section>
  <h3>Solution</h3>
  <ng-container *ngIf="iterations$ | async; let iterations; else noSolvingYet">
    <ng-container *ngIf="iterations && iterations.length; else noSolvingYet">
      <table mat-table [dataSource]="iterations">
        <ng-container matColumnDef="numberOfIteration">
          <th mat-header-cell *matHeaderCellDef> № </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.numberOfIteration}} </td>
        </ng-container>

        <ng-container matColumnDef="a">
          <th mat-header-cell *matHeaderCellDef> a </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.interval.begin | numberFormatting}} </td>
        </ng-container>

        <ng-container matColumnDef="b">
          <th mat-header-cell *matHeaderCellDef> b </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.interval.end | numberFormatting}} </td>
        </ng-container>

        <ng-container matColumnDef="y">
          <th mat-header-cell *matHeaderCellDef> y </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.y || null | numberFormatting}} </td>
        </ng-container>

        <ng-container matColumnDef="z">
          <th mat-header-cell *matHeaderCellDef> z </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.z || null | numberFormatting}} </td>
        </ng-container>

        <ng-container matColumnDef="fy">
          <th mat-header-cell *matHeaderCellDef> fy </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.fy || null | numberFormatting}} </td>
        </ng-container>

        <ng-container matColumnDef="fz">
          <th mat-header-cell *matHeaderCellDef> fz </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.fz || null | numberFormatting}} </td>
        </ng-container>

        <ng-container matColumnDef="x">
          <th mat-header-cell *matHeaderCellDef> x </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.x || null | numberFormatting}} </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
      </table>
    </ng-container>
  </ng-container>
  <ng-template #noSolvingYet>
    No solution
  </ng-template>
</section>

<section>
  <h3>Result</h3>
  <ng-container *ngIf="result; else noResultYet">
    <p>Extremum point: {{result.extremumPoint | numberFormatting}}</p>
    <p>Function value: {{result.functionValue | numberFormatting}}</p>
    <p>Interval: [{{result.interval.begin | numberFormatting}}, {{result.interval.end| numberFormatting}}]</p>
  </ng-container>
  <ng-template #noResultYet>
    <p *ngIf="errorMessage; else calculating">
      {{errorMessage}}
    </p>
    <ng-template #calculating>
      No result yet
    </ng-template>
  </ng-template>
</section>
